unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, SynaUtil, Synaser;

type

  { TfrmMain }

  TfrmMain = class(TForm)
    btnScanPorts: TButton;
    btnP26: TButton;
    btnP27: TButton;
    cboComPort: TComboBox;
    Label1: TLabel;
    shpP26: TShape;
    shpP27: TShape;
    tmrCheckRx: TTimer;
    procedure btnScanPortsClick(Sender: TObject);
    procedure btnP26Click(Sender: TObject);
    procedure btnP27Click(Sender: TObject);
    procedure cboComPortChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure tmrCheckRxTimer(Sender: TObject);

    procedure OpenPort;
    procedure CheckRx;


  private

  public

  end;

var
  frmMain   : TfrmMain;
  serial    : TblockSerial;
  connected : Boolean;


implementation

{$R *.lfm}

{ TfrmMain }

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  tmrCheckRx.Enabled := false;
  tmrCheckRx.Interval := 25;
  btnP26.Enabled := false;
  btnP27.Enabled := false;
  serial := TBlockSerial.Create;
  connected := false;
  btnScanPorts.Click;
end;

procedure TfrmMain.btnScanPortsClick(Sender: TObject);
begin
  cboComPort.Clear;
  cboComPort.Items.CommaText := GetSerialPortNames;
  cboComPort.DroppedDown := true;
end;

procedure TfrmMain.btnP26Click(Sender: TObject);
begin
  serial.SendByte(byte('A'));
end;

procedure TfrmMain.btnP27Click(Sender: TObject);
begin
  serial.SendByte(byte('B'));
end;

procedure TfrmMain.cboComPortChange(Sender: TObject);
begin
  OpenPort;
end;

procedure TfrmMain.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  if (serial <> nil) then
    begin
      tmrCheckRx.Enabled := false;
      serial.CloseSocket;
      serial.free;
    end;
end;

procedure TfrmMain.OpenPort;
begin
  if (connected = true) then
    begin
      tmrCheckRx.Enabled := false;
      serial.CloseSocket;
      connected := false
    end;

  if (cboComPort.ItemIndex >= 0) then
    begin
      serial.Connect(cboComPort.Text);
      serial.Config(115200, 8, 'N', SB1, False, False);
      if (serial.LastError = 0) then
        begin
          connected := true;
          Label1.Caption := 'Using';
        end
      else
        begin
          connected := false;
          Label1.Caption := 'Use';
        end;
    end;

  tmrCheckRx.Enabled := connected;
  btnP26.Enabled := connected;
  btnP27.Enabled := connected;
end;

procedure TfrmMain.CheckRx;
var
  response : byte;
begin
  while (serial.CanRead(2)) do                         // should work down to 9600 baud
  begin
    response := serial.RecvByte(0);
    case response of
      byte('a') : shpP26.Brush.Color := clForm;
      byte('A') : shpP26.Brush.Color := clRed;
      byte('b') : shpP27.Brush.Color := clForm;
      byte('B') : shpP27.Brush.Color := clRed;
    end;
  end;
end;

procedure TfrmMain.tmrCheckRxTimer(Sender: TObject);
begin
  CheckRx;
end;

end.

